Index: apps/app_queue.c
===================================================================
--- apps/app_queue.c	(revision 85485)
+++ apps/app_queue.c	(working copy)
@@ -100,7 +100,8 @@
 	QUEUE_STRATEGY_LEASTRECENT,
 	QUEUE_STRATEGY_FEWESTCALLS,
 	QUEUE_STRATEGY_RANDOM,
-	QUEUE_STRATEGY_RRMEMORY
+	QUEUE_STRATEGY_RRMEMORY,
+	QUEUE_STRATEGY_WRANDOM
 };
 
 static struct strategy {
@@ -112,6 +113,7 @@
 	{ QUEUE_STRATEGY_FEWESTCALLS, "fewestcalls" },
 	{ QUEUE_STRATEGY_RANDOM, "random" },
 	{ QUEUE_STRATEGY_RRMEMORY, "rrmemory" },
+	{ QUEUE_STRATEGY_WRANDOM, "wrandom" },
 };
 
 #define DEFAULT_RETRY		5
@@ -2514,6 +2516,9 @@
 		tmp->metric = ast_random() % 1000;
 		tmp->metric += mem->penalty * 1000000;
 		break;
+	case QUEUE_STRATEGY_WRANDOM:
+		tmp->metric = ast_random() % ((1 + mem->penalty) * 1000);
+		break;
 	case QUEUE_STRATEGY_FEWESTCALLS:
 		tmp->metric = mem->calls;
 		tmp->metric += mem->penalty * 1000000;
